function varargout = config(varargin)
% CONFIG MATLAB code for config.fig
%      CONFIG, by itself, creates a new CONFIG or raises the existing
%      singleton*.
%
%      H = CONFIG returns the handle to a new CONFIG or the handle to
%      the existing singleton*.
%
%      CONFIG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CONFIG.M with the given input arguments.
%
%      CONFIG('Property','Value',...) creates a new CONFIG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before config_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to config_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help config

% Last Modified by GUIDE v2.5 17-Sep-2014 11:55:15

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @config_OpeningFcn, ...
                   'gui_OutputFcn',  @config_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before config is made visible.
function config_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to config (see VARARGIN)

% Choose default command line output for config
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes config wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = config_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in button_confirm.
function button_confirm_Callback(hObject, eventdata, handles)
% hObject    handle to button_confirm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load_par;
close()



% --- Executes during object creation, after setting all properties.
function edit_f0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_f0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function edit_Af_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Af (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function edit_prf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_prf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function edit_dt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_dt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes during object creation, after setting all properties.
function edit_Np_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_dt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in cb_fm_law_bool.
function cb_fm_law_bool_Callback(hObject, eventdata, handles)
global tp dt fs T Af f0 fi
if (get(handles.cb_fm_law_bool,'Value'))
    set(handles.pushbutton_fm_law,'Visible','on');
    set(handles.select_FM,'Visible','on');
    load_par;
    Nm=ceil(T*fs);
    tp=linspace(0,tau,ceil(Nm*dt));
    fi=(4*Af/tau^2*tp.^2-4*Af/tau*tp+Af).*...
        [ones(1,ceil(length(tp)/2)) -1*ones(1,floor(length(tp)/2))]+f0;

else
    set(handles.text_FM_Law,'Visible','off');
    set(handles.pushbutton_fm_law,'Visible','off');
    set(handles.select_FM,'Visible','off');
end

% hObject    handle to cb_fm_law_bool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_fm_law_bool





% --- Executes on button press in pushbutton_fm_law.
function pushbutton_fm_law_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_fm_law (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global fi tp 
figure(1),
plot(tp,fi,'k'),title ('Instantaneous frequency');
xlabel('Time'), ylabel('fi(t)'), grid on, axis tight



% --- Executes during object creation, after setting all properties.
function edit_v_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_v (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function edit_Rt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Rt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in cb_multitarget_bool.
function cb_multitarget_bool_Callback(hObject, eventdata, handles)
% hObject    handle to cb_multitarget_bool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_multitarget_bool
if (get(handles.cb_multitarget_bool,'Value'))
    set(handles.text_multitarget,'Visible','on');
else
    set(handles.text_multitarget,'Visible','off');
end




% --- Executes during object creation, after setting all properties.
function mismatch_par1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mismatch_par1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function mismatch_par2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mismatch_par2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function edit_srr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_srr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in cb_mismatched_bool.
function cb_mismatched_bool_Callback(hObject, eventdata, handles)
% hObject    handle to cb_mismatched_bool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (get(handles.cb_mismatched_bool,'Value'))
    set(handles.mismatch_par1,'Visible','on');
    set(handles.mismatch_par1_edit,'Visible','on');
    set(handles.mismatch_par2,'Visible','on');
    set(handles.mismatch_par2_edit,'Visible','on');
    set(handles.select_mismatch,'Visible','on');
else
    set(handles.mismatch_par1,'Visible','off');
    set(handles.mismatch_par1_edit,'Visible','off');
    set(handles.mismatch_par2,'Visible','off');
    set(handles.mismatch_par2_edit,'Visible','off');
    set(handles.select_mismatch,'Visible','off');
end 
% Hint: get(hObject,'Value') returns toggle state of cb_mismatched_bool





% --- Executes on button press in cb_wn_bool.
function cb_wn_bool_Callback(hObject, eventdata, handles)
% hObject    handle to cb_wn_bool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (get(handles.cb_wn_bool,'Value'))
    set(handles.edit_p_n,'Visible','on');
else
    set(handles.edit_p_n,'Visible','off');
end
% Hint: get(hObject,'Value') returns toggle state of cb_wn_bool


% --- Executes on button press in cb_wn_bool.
function cb_clutter_bool_Callback(hObject, eventdata, handles)
% hObject    handle to cb_wn_bool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_wn_bool



% % --- Executes during object creation, after setting all properties.
% function edit17_CreateFcn(hObject, eventdata, handles)
% % hObject    handle to edit17 (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    empty - handles not created until after all CreateFcns called
% 
% % Hint: edit controls usually have a white background on Windows.
% %       See ISPC and COMPUTER.
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end






% --- Executes during object creation, after setting all properties.
function edit_p_n_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_p_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in select_mismatch.
function select_mismatch_Callback(hObject, eventdata, handles)
% hObject    handle to select_mismatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (get(hObject,'Value')==2)
    set(handles.mismatch_par1,'String','SLL=');
    set(handles.mismatch_par2,'String','m=');
    set(handles.mismatch_par1_edit,'String','-32')
    set(handles.mismatch_par2_edit,'String','2')
else
    set(handles.mismatch_par1,'String','K=');
    set(handles.mismatch_par2,'String','n=');
    set(handles.mismatch_par1_edit,'String','0.08')
    set(handles.mismatch_par2_edit,'String','2')
end
% Hints: contents = cellstr(get(hObject,'String')) returns select_mismatch contents as cell array
%        contents{get(hObject,'Value')} returns selected item from select_mismatch


% --- Executes during object creation, after setting all properties.
function select_mismatch_CreateFcn(hObject, eventdata, handles)
% hObject    handle to select_mismatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_v_Callback(hObject, eventdata, handles)
% hObject    handle to edit_v (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_v as text
%        str2double(get(hObject,'String')) returns contents of edit_v as a double



function edit_Rt_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Rt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_Rt as text
%        str2double(get(hObject,'String')) returns contents of edit_Rt as a double



function edit_srr_Callback(hObject, eventdata, handles)
% hObject    handle to edit_srr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_srr as text
%        str2double(get(hObject,'String')) returns contents of edit_srr as a double



function edit_f0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_f0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_f0 as text
%        str2double(get(hObject,'String')) returns contents of edit_f0 as a double



function edit_Af_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Af (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_Af as text
%        str2double(get(hObject,'String')) returns contents of edit_Af as a double



function edit_prf_Callback(hObject, eventdata, handles)
% hObject    handle to edit_prf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_prf as text
%        str2double(get(hObject,'String')) returns contents of edit_prf as a double



function edit_dt_Callback(hObject, eventdata, handles)
% hObject    handle to edit_dt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_dt as text
%        str2double(get(hObject,'String')) returns contents of edit_dt as a double



function edit_Np_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Np (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_Np as text
%        str2double(get(hObject,'String')) returns contents of edit_Np as a double



function mismatch_par1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to mismatch_par1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mismatch_par1_edit as text
%        str2double(get(hObject,'String')) returns contents of mismatch_par1_edit as a double



function mismatch_par2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to mismatch_par2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mismatch_par2_edit as text
%        str2double(get(hObject,'String')) returns contents of mismatch_par2_edit as a double



function edit_p_n_Callback(hObject, eventdata, handles)
% hObject    handle to edit_p_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_p_n as text
%        str2double(get(hObject,'String')) returns contents of edit_p_n as a double


% --- Executes on selection change in select_FM.
function select_FM_Callback(hObject, eventdata, handles)
% hObject    handle to select_FM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns select_FM contents as cell array
%        contents{get(hObject,'Value')} returns selected item from select_FM
global tp fi Af tau f0
p=get(handles.select_FM,'Value');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%FM Law Definition%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
switch p
    
    case 2
        set(handles.text_FM_Law,'Visible','off');
        fi=4*Af/tau^2*tp.^2-4*Af/tau*tp+Af+f0;
        
    case 3
        set(handles.text_FM_Law,'Visible','off');
        fi=Af/2*tan(pi*tp/(tau));
        
    case 4
        set(handles.text_FM_Law,'Visible','off');
        fi=[linspace(Af+f0,f0,floor(length(tp)/2)) ...
        linspace(f0,Af+f0,ceil(length(tp)/2))];
    
    case 5
        set(handles.text_FM_Law,'Visible','off');
        fi=[linspace(f0-Af/2,f0+Af/2,floor(length(tp)/2)) ...
        linspace(f0-Af/2,f0+Af/2,ceil(length(tp)/2))];

    case 6
        set(handles.text_FM_Law,'Visible','off');
        fi=sort(mod(1:length(tp),25))*Af/25+f0-Af/2;
        
    case 7
        set(handles.text_FM_Law,'Visible','on');
        fi=input(['Write your FM law:', char(10)]);
        
    otherwise
        set(handles.text_FM_Law,'Visible','off');
        fi=(4*Af/tau^2*tp.^2-4*Af/tau*tp+Af).*...
        [ones(1,ceil(length(tp)/2)) -1*ones(1,floor(length(tp)/2))]+f0;
end
% --- Executes during object creation, after setting all properties.
function select_FM_CreateFcn(hObject, eventdata, handles)
% hObject    handle to select_FM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
